﻿#    '''Copyright (C) <2019> Birgitta Dresp-Langley 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    GNU General Public License for this program <https://www.gnu.org/licenses/>.'''
        
import sys
import cv2

import py2exe
import os
import numpy as np
import time
import random
from distutils.core import setup
import winsound
from tkinter import *

# excel files
import xlrd
import xlwt


# time in seconds
delai_clavier_son = 0.8
# or milliseconds
duree_son = 0.1

class RTimagesRandomOrder:

    def __init__(self,file_xl_name,fond,son):



        # result file 
        self.dir_path = os.path.dirname(os.path.realpath('__file__'))
  
        # initialize excel result file 
        if file_xl_name== "":
            file_xl_name = "test1"
        self.excel = file_xl_name
        self.wb = xlwt.Workbook()
        self.ws = self.wb.add_sheet('A Test Sheet')

        
        # initialize path to image folders and possible backgrounds     
        if fond == 0:
            self.path = "Images/ImagesW\\"
            self.path_fond = "Images\\WBckrgd"
            self.ws.write(2, 3, "Screen Background: White")
        else:
            self.path = "Images/ImagesG\\"
            self.path_fond = "Images\\GBckgrd"
            self.ws.write(2, 3, "Screen Background: Gray")

        # initialize possible alert sound frequencies
        if son == 0:
            self.ws.write(1, 3, "Frequency: 0 Hz")
            self.sound = None
        elif son == 1:
            self.ws.write(1, 3, "Frequency: 200 Hz")
            self.sound = "Sons/200Hz.wav"
        elif son == 2:
            self.ws.write(1, 3, "Frequency: 1000 Hz")
            self.sound = "Sons/1000Hz.wav"
        else:
            self.ws.write(1, 3, "Frequency: 2000 Hz")
            self.sound = "Sons/2000Hz.wav"

        # creates background window
        img_fond = cv2.imread(self.path_fond,1)
        cv2.namedWindow("fond",cv2.WINDOW_NORMAL)
        cv2.setWindowProperty("fond", cv2.WND_PROP_FULLSCREEN, cv2.WINDOW_FULLSCREEN);
        cv2.imshow("fond",img_fond)

        cv2.waitKey(0) & 0xFF

    def showImages(self):
        dirs = os.listdir( self.path )

        # screen data
        fenetre = Tk()
        largeur_ecran = fenetre.winfo_screenheight()
        longueur_ecran = fenetre.winfo_screenwidth()
        cote_image = int(largeur_ecran/1.5)
        fenetre.destroy()

        # randomization presentation order of images
        for i in range(0,len(dirs)):

            # random order generation
            picChoiceFirst = random.choice(dirs)
            dirs.remove(picChoiceFirst)
            print(picChoiceFirst)
            # attente et son
            time.sleep(delai_clavier_son)
            winsound.PlaySound(self.sound,winsound.SND_ASYNC)
            time.sleep(duree_son)
            winsound.PlaySound(None,winsound.SND_NODEFAULT)

            # image presentation 
            img = cv2.imread(os.path.join(self.dir_path, self.path, picChoiceFirst),1)
            img = cv2.resize(img,(cote_image,cote_image))
            cv2.imshow("",img)
            cv2.moveWindow("",int(longueur_ecran/2-cote_image/2),int(largeur_ecran/2-cote_image/2))
            cv2.namedWindow("",cv2.WND_PROP_FULLSCREEN)

            # counting 
            timestamp = time.time()

            # wait for a keyboard response 1 or 2
            k = cv2.waitKey(0) & 0xFF

            while True:
                if cv2.getWindowProperty("",1) == -1 :
                    cv2.destroyAllWindows()
                    print("WINDOW CLOSED")
                    sys.exit()
                if k == ord('1'):
                    break
                if k== ord('2'):
                    break
                print ("PLEASE PRESS 1 or 2 ON THE KEYBOARD")
                k = cv2.waitKey(0) & 0xFF

            # writes 1 or 2 into an array 
            if k == ord('1'):      
                self.ws.write(i, 0, 1)            
                
            elif k == ord('2'): 
                self.ws.write(i, 0, 2)

            cv2.destroyWindow("")

            # assigns the right number 1 or 2 with the corresponding RT and writes them into to the excel file
            self.ws.write(i, 1, (time.time()-timestamp)*1000)            
            self.ws.write(i, 2, picChoiceFirst)            

        # saves excel file, closes txt file and windows
        self.ws.write(0, 3, "NomSujetSession: " + self.excel)

        self.wb.save("RESULTS/" + self.excel + ".xls")
        cv2.destroyAllWindows()


if __name__ == '__main__':
        birgittaSoftware = RTimagesRandomOrder("",1,1)
        birgittaSoftware.showImages()
