﻿#    '''Copyright (C) <2019> Birgitta Dresp-Langley
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    <https://www.gnu.org/licenses/>.'''

from tkinter import *
import RTimagesRandomOrder
import os

class Menu :

    def __init__(self):

        # initializations 
        self.fenetre = Tk()
        self.fenetre.title("Welcome v2")
        largeur_ecran = self.fenetre.winfo_screenheight()
        longueur_ecran = self.fenetre.winfo_screenwidth()
        self.fenetre.geometry("250x600+"+str(int(longueur_ecran/2-125))+"+"+str(int(largeur_ecran/2-300)))
        
        # window labels
        label = Label(self.fenetre, text="Welcome")
        label.pack(pady=5)

        # alert sounds 
        Frame1 = Frame(self.fenetre, borderwidth=2, relief=GROOVE)
        Frame1.pack(pady=10)
        Label(Frame1, text="Please choose the desired frequency").pack(padx=10, pady=10)
        self.son = IntVar() 
        bouton1 = Radiobutton(Frame1, text="No sound", variable=self.son, value=0)
        bouton2 = Radiobutton(Frame1, text="Low frequency", variable=self.son, value=1)
        bouton3 = Radiobutton(Frame1, text="Medium frequency", variable=self.son, value=2)
        bouton4 = Radiobutton(Frame1, text="High frequency", variable=self.son, value=3)
        bouton1.pack(pady=5)
        bouton2.pack(pady=5)
        bouton3.pack(pady=5)
        bouton4.pack(pady=5)
        bouton1.select()

        # backgrounds
        Frame2 = Frame(self.fenetre, borderwidth=2, relief=GROOVE)
        Frame2.pack(pady=10,padx=5)
        Label(Frame2, text="Please choose the background color").pack(padx=10, pady=10)
        self.fond = IntVar() 
        bouton1 = Radiobutton(Frame2, text="White background", variable=self.fond, value=0)
        bouton2 = Radiobutton(Frame2, text="Gray background", variable=self.fond, value=1)
        bouton1.pack(pady=5)
        bouton2.pack(pady=5)
        bouton1.select()

        # excel file name
        self.file_xl_name = StringVar() 
        file_xl = Label(self.fenetre, text="Enter your initials and session number")
        file_xl.pack(pady=5)
        file_xl_ent = Entry(self.fenetre,textvariable=self.file_xl_name)
        file_xl_ent.pack()

        # start preliminary trials (fct begin)
        Begin = Button(self.fenetre, text = 'Begin the test', command=self.begin)
        Begin.pack(pady=10)

        # start a test session (fct begin)
        BeginAll = Button(self.fenetre, text = 'Begin the complete test', command=self.beginAll)
        BeginAll.pack(pady=10)
        
        # end a test session (fct end)
        End = Button(self.fenetre, text = 'End the test', command=self.end)
        End.pack(pady=10)

        self.fenetre.mainloop()

    def begin(self):
        if not os.path.exists("RESULTS/"):
            os.makedirs("RESULTS/")
        nom = self.file_xl_name.get()
        self.fenetre.destroy()
        birgittaSoftware = RTimagesRandomOrder.RTimagesRandomOrder( nom,self.fond.get(),self.son.get())
        birgittaSoftware.showImages()
        
    def beginAll(self):
        self.fenetre.destroy()
        if not os.path.exists("RESULTS/" + self.file_xl_name.get()):
            os.makedirs("RESULTS/" +self.file_xl_name.get())
        for i in range(0,8):
            birgittaSoftware = RTimagesRandomOrder.RTimagesRandomOrder( self.file_xl_name.get() + '/' + self.file_xl_name.get()+str(i+1),int(i/4),i%4)
            birgittaSoftware.showImages()  

    def end(self):
        self.fenetre.destroy()
        sys.exit()

if __name__ == '__main__':
    menu = Menu()
